#!/bin/bash
# このファイルのあるディレクトリに移動する
cd $(dirname $0)

# 生成済みのファイルを削除(thriftがすでに不要になったファイルを削除してくれないため)
rm -rf gen-java gen-php gen-js gen-html js

# ライブラリを生成
thrift -r -v -strict -gen java thrift/myapp.thrift
thrift -r -v -strict -gen php:server thrift/myapp.thrift
thrift -r -v -strict -gen js:jquery thrift/myapp.thrift
thrift -r -v -strict -gen html thrift/myapp.thrift

# js/ 以下を生成（*_types.jsを先に結合しないと未定義変数エラーになる）
mkdir js
find gen-js -name "*_types.js" | xargs cat > js/myapp.js
find gen-js -type f -and -not -name "*_types.js" | xargs cat >> js/myapp.js
