<?php
namespace MyApp\Entry;

/**
 * Autogenerated by Thrift Compiler (0.9.2)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
use Thrift\Base\TBase;
use Thrift\Type\TType;
use Thrift\Type\TMessageType;
use Thrift\Exception\TException;
use Thrift\Exception\TProtocolException;
use Thrift\Protocol\TProtocol;
use Thrift\Protocol\TBinaryProtocolAccelerated;
use Thrift\Exception\TApplicationException;


/**
 * エントリの種別
 */
final class EntryType {
  /**
   * 文字だけのエントリ
   */
  const TEXT = 1;
  /**
   * 写真付きエントリ
   */
  const PHOTO = 2;
  static public $__names = array(
    1 => 'TEXT',
    2 => 'PHOTO',
  );
}

/**
 * エントリ情報
 */
class Entry {
  static $_TSPEC;

  /**
   * @var int
   */
  public $id = null;
  /**
   * @var \MyApp\User\User
   */
  public $owner = null;
  /**
   * @var int
   */
  public $entryType = null;
  /**
   * エントリのテキスト
   * 
   * @var string
   */
  public $text = null;
  /**
   * エントリの画像。EntryTypeがTEXTのときはnull
   * 
   * @var string
   */
  public $photoUrl = null;

  public function __construct($vals=null) {
    if (!isset(self::$_TSPEC)) {
      self::$_TSPEC = array(
        1 => array(
          'var' => 'id',
          'type' => TType::I64,
          ),
        2 => array(
          'var' => 'owner',
          'type' => TType::STRUCT,
          'class' => '\MyApp\User\User',
          ),
        3 => array(
          'var' => 'entryType',
          'type' => TType::I32,
          ),
        4 => array(
          'var' => 'text',
          'type' => TType::STRING,
          ),
        5 => array(
          'var' => 'photoUrl',
          'type' => TType::STRING,
          ),
        );
    }
    if (is_array($vals)) {
      if (isset($vals['id'])) {
        $this->id = $vals['id'];
      }
      if (isset($vals['owner'])) {
        $this->owner = $vals['owner'];
      }
      if (isset($vals['entryType'])) {
        $this->entryType = $vals['entryType'];
      }
      if (isset($vals['text'])) {
        $this->text = $vals['text'];
      }
      if (isset($vals['photoUrl'])) {
        $this->photoUrl = $vals['photoUrl'];
      }
    }
  }

  public function getName() {
    return 'Entry';
  }

  public function read($input)
  {
    $xfer = 0;
    $fname = null;
    $ftype = 0;
    $fid = 0;
    $xfer += $input->readStructBegin($fname);
    while (true)
    {
      $xfer += $input->readFieldBegin($fname, $ftype, $fid);
      if ($ftype == TType::STOP) {
        break;
      }
      switch ($fid)
      {
        case 1:
          if ($ftype == TType::I64) {
            $xfer += $input->readI64($this->id);
          } else {
            $xfer += $input->skip($ftype);
          }
          break;
        case 2:
          if ($ftype == TType::STRUCT) {
            $this->owner = new \MyApp\User\User();
            $xfer += $this->owner->read($input);
          } else {
            $xfer += $input->skip($ftype);
          }
          break;
        case 3:
          if ($ftype == TType::I32) {
            $xfer += $input->readI32($this->entryType);
          } else {
            $xfer += $input->skip($ftype);
          }
          break;
        case 4:
          if ($ftype == TType::STRING) {
            $xfer += $input->readString($this->text);
          } else {
            $xfer += $input->skip($ftype);
          }
          break;
        case 5:
          if ($ftype == TType::STRING) {
            $xfer += $input->readString($this->photoUrl);
          } else {
            $xfer += $input->skip($ftype);
          }
          break;
        default:
          $xfer += $input->skip($ftype);
          break;
      }
      $xfer += $input->readFieldEnd();
    }
    $xfer += $input->readStructEnd();
    return $xfer;
  }

  public function write($output) {
    $xfer = 0;
    $xfer += $output->writeStructBegin('Entry');
    if ($this->id !== null) {
      $xfer += $output->writeFieldBegin('id', TType::I64, 1);
      $xfer += $output->writeI64($this->id);
      $xfer += $output->writeFieldEnd();
    }
    if ($this->owner !== null) {
      if (!is_object($this->owner)) {
        throw new TProtocolException('Bad type in structure.', TProtocolException::INVALID_DATA);
      }
      $xfer += $output->writeFieldBegin('owner', TType::STRUCT, 2);
      $xfer += $this->owner->write($output);
      $xfer += $output->writeFieldEnd();
    }
    if ($this->entryType !== null) {
      $xfer += $output->writeFieldBegin('entryType', TType::I32, 3);
      $xfer += $output->writeI32($this->entryType);
      $xfer += $output->writeFieldEnd();
    }
    if ($this->text !== null) {
      $xfer += $output->writeFieldBegin('text', TType::STRING, 4);
      $xfer += $output->writeString($this->text);
      $xfer += $output->writeFieldEnd();
    }
    if ($this->photoUrl !== null) {
      $xfer += $output->writeFieldBegin('photoUrl', TType::STRING, 5);
      $xfer += $output->writeString($this->photoUrl);
      $xfer += $output->writeFieldEnd();
    }
    $xfer += $output->writeFieldStop();
    $xfer += $output->writeStructEnd();
    return $xfer;
  }

}

/**
 * 定数で定義されていない言語を指定された時の例外
 */
class InvalidLanguageException extends TException {
  static $_TSPEC;


  public function __construct() {
    if (!isset(self::$_TSPEC)) {
      self::$_TSPEC = array(
        );
    }
  }

  public function getName() {
    return 'InvalidLanguageException';
  }

  public function read($input)
  {
    $xfer = 0;
    $fname = null;
    $ftype = 0;
    $fid = 0;
    $xfer += $input->readStructBegin($fname);
    while (true)
    {
      $xfer += $input->readFieldBegin($fname, $ftype, $fid);
      if ($ftype == TType::STOP) {
        break;
      }
      switch ($fid)
      {
        default:
          $xfer += $input->skip($ftype);
          break;
      }
      $xfer += $input->readFieldEnd();
    }
    $xfer += $input->readStructEnd();
    return $xfer;
  }

  public function write($output) {
    $xfer = 0;
    $xfer += $output->writeStructBegin('InvalidLanguageException');
    $xfer += $output->writeFieldStop();
    $xfer += $output->writeStructEnd();
    return $xfer;
  }

}


