<?php
require __DIR__ . '/../vendor/autoload.php';
use Thrift\Transport\TPhpStream;
use Thrift\Protocol\TBinaryProtocol;
use MyApp\User\UserServiceIf;
use MyApp\User\UserServiceProcessor;
use MyApp\User\UserOption;
use MyApp\User\User;
use MyApp\User\Constant;

class UserServiceHandler implements UserServiceIf {
  public function findByIds(array $ids, UserOption $opt) {
    // ここで本来はデータベースからユーザ一覧を取得
    return new User(['id'=>1, 'name'=>'test',
        'language'=>Constant::get('LANGUAGE_EN')]);
  }
}

try {
  $handler = new UserServiceHandler();
  $processor = new UserServiceProcessor($handler);
  $transport = new TPhpStream(TPhpStream::MODE_R | TPhpStream::MODE_W);
  $protocol = new TBinaryProtocol($transport);
  header('Content-Type: application/x-thrift');
  $transport->open();
  $processor->process($protocol, $protocol);
  $transport->close();
} catch (Exception $ex) {
  // 標準出力に出さずログにだけ記録する
  file_put_contents('php://stderr', print_r($ex, TRUE));
}
